# 例外情况

> 译者：[OSGeo 中国](https://www.osgeo.cn/)

## 内置异常引用

下面是scrapy中包含的所有异常及其用法的列表。

### DropItem

```py
exception scrapy.exceptions.DropItem
```

必须由项管道阶段引发的异常才能停止处理项。有关详细信息，请参阅 [项目管道](item-pipeline.html#topics-item-pipeline) .

### CloseSpider

```py
exception scrapy.exceptions.CloseSpider(reason='cancelled')
```

可以从 Spider 回调中引发此异常以请求关闭/停止 Spider 。支持的参数：

| 参数: | **reason** (_str_) -- 关闭的原因 |
| --- | --- |

例如：：

```py
def parse_page(self, response):
    if 'Bandwidth exceeded' in response.body:
        raise CloseSpider('bandwidth_exceeded')

```

### DontCloseSpider

```py
exception scrapy.exceptions.DontCloseSpider
```

此异常可以在 [`spider_idle`](signals.html#std:signal-spider_idle) 防止 Spider 关闭的信号处理程序。

### IgnoreRequest

```py
exception scrapy.exceptions.IgnoreRequest
```

调度程序或任何下载器中间件都可以引发此异常，以指示应忽略请求。

### NotConfigured

```py
exception scrapy.exceptions.NotConfigured
```

某些组件可能会引发此异常，以指示它们将保持禁用状态。这些组成部分包括：

> *   扩展
> *   项目管道
> *   下载器中心件
> *   Spider 中心件

必须在组件的中引发异常 `__init__` 方法。

### NotSupported

```py
exception scrapy.exceptions.NotSupported
```

引发此异常以指示不支持的功能。